Package com.ads.api.util

# Class LineageUtil

java.lang.Object
com.ads.api.util.BaseUtil
com.ads.api.util.LineageUtil

public class LineageUtil extends com.ads.api.util.BaseUtil
Contains the methods to get the lineage information on system/environment/table/column. RequestStatus return type methods will result in being returned as either true or false as its status.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.ads.api.util.BaseUtil

  `com.ads.api.util.BaseUtil.TokenType`

- ## Field Summary

  ### Fields inherited from class com.ads.api.util.BaseUtil

  `AUTH_TOKEN, AUTH_TOKEN_TYPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<SMColumn>`
  `getColumnDetails(APIConstants.EndPointType endPointType, int mappingSequenceId)`
  Returns the List object for the specified mappingSequenceId.
  `Map<Integer,List<SMColumn>>`
  `getColumnDetails(APIConstants.EndPointType endPointType, ArrayList<Integer> mappingSequenceIds)`
  Returns the Map<Integer, List> object for the specified list of mappingSequenceIds.
  `String`
  `getColumnDetailsAs(String endPointType, int mappingSequenceId, String outputFormat)`
  Returns the List Objects String in the form of JSON for the specified mappingSequenceId.The returned SMColumn Objects contains the details about the source and target columns like systemName, environmentName, tableName, columnName, columnDataType etc..
  `String`
  `getColumnDetailsAs(String endPointType, String mappingSequenceIds, String outputFormat)`
  Returns the List Objects String in the form of JSON for the specified mappingSequenceIds.The returned SMColumn Objects contains the details about the source and target columns like systemName, environmentName, tableName, columnName, columnDataType etc..
  `Lineage`
  `getColumnLineage(APIConstants.LineageType lineageType, String systemName, String environmentName, String tableName, String columnName, String projectIds)`
  Returns the Lineage object for the specified system, environment, table and column name.
  `String`
  `getColumnLineageAs(String lineageType, String systemName, String environmentName, String tableName, String columnName, String projectIds, String outputFormat)`
  Returns the Lineage Object String in the form of JSON for the specified system, environment, table and column name.
  `List<SMColumn>`
  `getColumns(APIConstants.EndPointType endPointType, String systemName, String environmentName, String tableName, EnumSet<APIConstants.PropertiesType> propertiesTypes, String projectIds)`
  Returns the List objects for the specified systemName, environmentName and tableName.
  `Map<String,Map<String,Map<String,List<SMColumn>>>>`
  `getColumns(APIConstants.EndPointType endPointType, HashMap<String,HashMap<String,ArrayList<String>>> systemEnvironmentTableMap, EnumSet<APIConstants.PropertiesType> propertiesTypes, String projectIds)`
  Returns the Map<String, Map<String, Map<String, List>>> object for the specified systemEnvironmentTableMap.
  `String`
  `getColumnsAs(String endPointType, String systemEnvironmentTableJsonArray, String propertiesTypes, String projectIds, String outputFormat)`
  Returns the List Objects String in the form of JSON for the specified systemName, environmentName and tableName.
  `String`
  `getColumnsAs(String endPointType, String systemName, String environmentName, String tableName, String propertiesTypes, String projectIds, String outputFormat)`
  Returns the List Objects String in the form of JSON for the specified systemName, environmentName and tableName.
  `Lineage`
  `getEnvironmentLineage(APIConstants.LineageType lineageType, String systemName, String environmentName, String projectIds)`
  Returns the Lineage object for the specified system and environment name.
  `String`
  `getEnvironmentLineageAs(String lineageType, String systemName, String environmentName, String projectIds, String outputFormat)`
  Returns the Lineage Object String in the form of JSON for the specified system and environment name.
  `List<SMEnvironment>`
  `getEnvironments(APIConstants.EndPointType endPointType, String systemName, String projectIds)`
  Returns the List objects for the specified systemName.
  `Map<String,List<SMEnvironment>>`
  `getEnvironments(APIConstants.EndPointType endPointType, ArrayList<String> systemNames, String projectIds)`
  Returns the Map<String, List> object for the specified list of systemNames.
  `String`
  `getEnvironmentsAs(String endPointType, String systemName, String projectIds, String outputFormat)`
  Returns the List Objects String in the form of JSON for the specified systemName.
  `String`
  `getEnvironmentsBySystemsAs(String endPointType, String systemNames, String projectIds, String outputFormat)`
  Returns the List Objects String in the form of JSON for the specified systemName.
  `Lineage`
  `getSystemLineage(APIConstants.LineageType lineageType, String systemName, String projectIds)`
  Returns the Lineage object for the specified system name.
  `String`
  `getSystemLineageAs(String lineageType, String systemName, String projectIds, String outputFormat)`
  Returns the Lineage Object String in the form of JSON for the specified system name.
  `Lineage`
  `getTableLineage(APIConstants.LineageType lineageType, String systemName, String environmentName, String tableName, String projectIds)`
  Returns the Lineage object for the specified system, environment and table name.
  `String`
  `getTableLineageAs(String lineageType, String systemName, String environmentName, String tableName, String projectIds, String outputFormat)`
  Returns the Lineage object String in the form of JSON for the specified system, environment and table name.
  `List<SMTable>`
  `getTables(APIConstants.EndPointType endPointType, String systemName, String environmentName, String projectIds)`
  Returns the List objects for the specified systemName and environmentName.
  `Map<String,Map<String,List<SMTable>>>`
  `getTables(APIConstants.EndPointType endPointType, HashMap<String,ArrayList<String>> systemEnvironmentMap, String projectIds)`
  Returns the Map<String, Map<String, List>> object for the specified systemEnvironmentMap.
  `String`
  `getTablesAs(String endPointType, String systemEnvironmentJsonArray, String projectIds, String outputFormat)`
  Returns the List Objects String in the form of JSON for the specified systemName and environmentName.
  `String`
  `getTablesAs(String endPointType, String systemName, String environmentName, String projectIds, String outputFormat)`
  Returns the List Objects String in the form of JSON for the specified systemName and environmentName.
  `void`
  `pauseLineageSync(long seconds)`
  It will pause the synchronization process of lineage for the given time.
  `void`
  `resetLineageData()`
  `void`
  `syncLineageData()`

  ### Methods inherited from class com.ads.api.util.BaseUtil

  `getAccessToken, getAccessTokenType, getTokenType, getUserDetails, permissionDeniedMessage, permissionDeniedStatus, setAccessToken, setAccessTokenType`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### getSystemLineage

    public Lineage getSystemLineage(APIConstants.LineageType lineageType, String systemName, String projectIds) throws Exception
    Returns the Lineage object for the specified system name. The returned Lineage object contains the details about the source and target systems like systemName.
    Specification of systemName and projectIds are mandatory, and the valid types of lineageType are `APIConstants.LineageType.FORWARD`, `APIConstants.LineageType.REVERSE`, `APIConstants.LineageType.DUAL`. And the projectIds value should be like "1,2,3.." to get the lineage on specific projects and "null" to get the lineage on all projects.
    Parameters:
      `lineageType` - LineageType - valid types FORWARD, REVERSE, DUAL.
      `systemName` - String
      `projectIds` - String - value should be like "1,2,3..."
    Returns:
      Lineage Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getEnvironmentLineage

    public Lineage getEnvironmentLineage(APIConstants.LineageType lineageType, String systemName, String environmentName, String projectIds) throws Exception
    Returns the Lineage object for the specified system and environment name. The returned Lineage object contains the details about the source and target environments like systemName, environmentName.
    Specification of systemName, environmentName and projectIds are mandatory, and the valid types of lineageType are `APIConstants.LineageType.FORWARD`, `APIConstants.LineageType.REVERSE`, `APIConstants.LineageType.DUAL`. And the projectIds value should be like "1,2,3.." to get the lineage on specific projects and "null" to get the lineage on all projects.
    Parameters:
      `lineageType` - LineageType - valid types FORWARD, REVERSE, DUAL.
      `systemName` - String
      `environmentName` - String
      `projectIds` - String - value should be like "1,2,3..."
    Returns:
      Lineage Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getTableLineage

    public Lineage getTableLineage(APIConstants.LineageType lineageType, String systemName, String environmentName, String tableName, String projectIds) throws Exception
    Returns the Lineage object for the specified system, environment and table name. The returned Lineage object contains the details about the source and target tables like systemName, environmentName, tableName.
    Specification of systemName, environmentName, tableName and projectIds are mandatory, and the valid types of lineageType are `APIConstants.LineageType.FORWARD`, `APIConstants.LineageType.REVERSE`, `APIConstants.LineageType.DUAL`. And the projectIds value should be like "1,2,3.." to get the lineage on specific projects and "null" to get the lineage on all projects.
    Parameters:
      `lineageType` - LineageType - valid types FORWARD, REVERSE, DUAL.
      `systemName` - String
      `environmentName` - String
      `tableName` - String
      `projectIds` - String
    Returns:
      Lineage Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getColumnLineage

    public Lineage getColumnLineage(APIConstants.LineageType lineageType, String systemName, String environmentName, String tableName, String columnName, String projectIds) throws Exception
    Returns the Lineage object for the specified system, environment, table and column name. The returned Lineage object contains the details about the source and target columns like systemName, environmentName, tableName, columnName.
    Specification of systemName, environmentName, tableName, columnName and projectIds are mandatory, and the valid types of lineageType are `APIConstants.LineageType.FORWARD`, `APIConstants.LineageType.REVERSE`, `APIConstants.LineageType.DUAL`. And the projectIds value should be like "1,2,3.." to get the lineage on specific projects and "null" to get the lineage on all projects.
    Parameters:
      `lineageType` - LineageType - valid types FORWARD, REVERSE, DUAL.
      `systemName` - String
      `environmentName` - String
      `tableName` - String
      `columnName` - String
      `projectIds` - String
    Returns:
      Lineage Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getColumnDetails

    public List<SMColumn> getColumnDetails(APIConstants.EndPointType endPointType, int mappingSequenceId) throws Exception
    Returns the List object for the specified mappingSequenceId. The returned SMColumn objects contains the details about the source and target columns like systemName, environmentName, tableName, columnName, columnDataType etc..
    Specification of mappingSequenceId and endPointType are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned column object will have the source information like source system name, source environment name etc.. If we specify endPointType as TARGET then the returned column object will have the target information like target system name, target environment name etc.. If we specify endPointType as BOTH then the returned column object will have both the source and target information like source system name, source environment name, target system name, target environment name etc..
    Parameters:
      `endPointType` - EndPointType - valid types SOURCE, TARGET, BOTH.
      `mappingSequenceId` - int
    Returns:
      List Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getColumnDetails

    public Map<Integer,List<SMColumn>> getColumnDetails(APIConstants.EndPointType endPointType, ArrayList<Integer> mappingSequenceIds) throws Exception
    Returns the Map<Integer, List> object for the specified list of mappingSequenceIds. The returned Map object contains the key as mappingSequenceId and the values as List objects, and these column objects contains the details about the source and target columns like systemName, environmentName, tableName, columnName, columnDataType etc..
    Specification of mappingSequenceIds and endPointType are mandatory, and the valid values of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned column object will have the source information like source system name, source environment name etc.. If we specify endPointType as TARGET then the returned column object will have the target information like target system name, target environment name etc.. If we specify endPointType as BOTH then the returned column object will have both the source and target information like source system name, source environment name, target system name, target environment name etc..
    Parameters:
      `endPointType` - EndPointType - valid types SOURCE, TARGET, BOTH.
      `mappingSequenceIds` - List
    Returns:
      Map<Integer, List> Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getEnvironments

    public List<SMEnvironment> getEnvironments(APIConstants.EndPointType endPointType, String systemName, String projectIds) throws Exception
    Returns the List objects for the specified systemName. The returned SMEnvironment objects contains the details like systemName, environmentName.
    Specification of endPointType, systemName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned environment object will have the source information like source system name, source environment name etc.. If we specify endPointType as TARGET then the returned environment object will have the target information like target system name, target environment name etc.. If we specify endPointType as BOTH then the returned environment object will have both the source and target information like source system name, source environment name, target system name, target environment name etc.. And the projectIds value should be like "1,2,3.." to get the list of environments of specific projects and "null" to get the list of environments of all projects.
    Parameters:
      `endPointType` - EndPointType - valid types SOURCE, TARGET, BOTH.
      `systemName` - String
      `projectIds` - String
    Returns:
      List Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getEnvironments

    public Map<String,List<SMEnvironment>> getEnvironments(APIConstants.EndPointType endPointType, ArrayList<String> systemNames, String projectIds) throws Exception
    Returns the Map<String, List> object for the specified list of systemNames. The returned Map object contains the key as systemName and values as List objects , and these environment objects contains the details like systemName, environmentName.
    Specification of endPointType, systemName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned environment object will have the source information like source system name, source environment name etc.. If we specify endPointType as TARGET then the returned environment object will have the target information like target system name, target environment name etc.. If we specify endPointType as BOTH then the returned environment object will have both the source and target information like source system name, source environment name, target system name, target environment name etc.. And the projectIds value should be like "1,2,3.." to get the list of environments of specific projects and "null" to get the list of environments of all projects.
    Parameters:
      `endPointType` - EndPointType - valid types SOURCE, TARGET, BOTH.
      `systemNames` - List
      `projectIds` - String
    Returns:
      Map<String, List> Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getTables

    public List<SMTable> getTables(APIConstants.EndPointType endPointType, String systemName, String environmentName, String projectIds) throws Exception
    Returns the List objects for the specified systemName and environmentName. The returned SMTable objects contains the details like systemName, environmentName and tableName.
    Specification of endPointType, systemName, environmentName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned table object will have the source information like source system name, environment name and table name etc.. If we specify endPointType as TARGET then the returned table object will have the target information like target system name, environment name and table name etc.. If we specify endPointType as BOTH then the returned table object will have both the source and target information like source system name, source environment name, source table name, target system name, target environment name , target table name etc.. And the projectIds value should be like "1,2,3.." to get the list of tables of specific projects and "null" to get the list of tables of all projects.
    Parameters:
      `endPointType` - EndPointType - valid types SOURCE, TARGET, BOTH.
      `systemName` - String
      `environmentName` - String
      `projectIds` - String
    Returns:
      List Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getTables

    public Map<String,Map<String,List<SMTable>>> getTables(APIConstants.EndPointType endPointType, HashMap<String,ArrayList<String>> systemEnvironmentMap, String projectIds) throws Exception
    Returns the Map<String, Map<String, List>> object for the specified systemEnvironmentMap. The returned Map object contains the key as systemName and values as map of environment name and List objects , and these table objects contains the details like systemName, environmentName and tableName.
    Specification of endPointType, systemName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned table object will have the source information like source system name, environment name and table name etc.. If we specify endPointType as TARGET then the returned table object will have the target information like target system name, environment name and table name, etc.. If we specify endPointType as BOTH then the returned table object will have both the source and target information like source system name, source environment name,source table name, target system name, target environment name, target table name etc.. And the projectIds value should be like "1,2,3.." to get the list of tables of specific projects and "null" to get the list of tables of all projects.
    Parameters:
      `endPointType` - EndPointType - valid types SOURCE, TARGET, BOTH.
      `systemEnvironmentMap` - HashMap<String, ArrayList> @param pr ojectIds String
    Returns:
      Map<String, Map<String, List>> Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getColumns

    public List<SMColumn> getColumns(APIConstants.EndPointType endPointType, String systemName, String environmentName, String tableName, EnumSet<APIConstants.PropertiesType> propertiesTypes, String projectIds) throws Exception
    Returns the List objects for the specified systemName, environmentName and tableName. The returned SMColumn objects contains the details like systemName, environmentName, tableName and columnName.
    Specification of endPointType, systemName, environmentName, tableName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned column object will have the source information like source system name, environment name, table name and column name etc.. If we specify endPointType as TARGET then the returned column object will have the target information like target system name, environment name, table name and column name etc.. If we specify endPointType as BOTH then the returned column object will have both the source and target information like source system name, source environment name, source table name,source column name, target system name, target environment name , target table name and target column name etc.. And the projectIds value should be like "1,2,3.." to get the list of columns of specific projects and "null" to get the list of columns of all projects.
    Valid types of propertiesTypes are `APIConstants.PropertiesType.TECHNICAL`, `APIConstants.PropertiesType.BUSINESS`,`APIConstants.PropertiesType.NONE` If we specify the propertiesTypes as BUSINESS then the column object will have business properties like colum definition, comments etc.. If we specify the propertiesTypes as TECHNICAL then the column object will have technical properties like column length,precision etc.. If we specify the propertiesTypes as NONE then the column object will have only system,environment,table and column name only.
    Parameters:
      `endPointType` - EndPointType - valid types SOURCE, TARGET, BOTH.
      `systemName` - String
      `environmentName` - String
      `tableName` - String
      `projectIds` - String
      `propertiesTypes` - EnumSet - valid types TECHNICAL, BUSINESS, NONE.
    Returns:
      List Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getColumns

    public Map<String,Map<String,Map<String,List<SMColumn>>>> getColumns(APIConstants.EndPointType endPointType, HashMap<String,HashMap<String,ArrayList<String>>> systemEnvironmentTableMap, EnumSet<APIConstants.PropertiesType> propertiesTypes, String projectIds) throws Exception
    Returns the Map<String, Map<String, Map<String, List>>> object for the specified systemEnvironmentTableMap. The returned SMColumn objects contains the details like systemName, environmentName, tableName and columnName.
    Specification of endPointType, systemName, environmentName, tableName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned column object will have the source information like source system name, environment name, table name and column name etc.. If we specify endPointType as TARGET then the returned column object will have the target information like target system name, environment name, table name and column name etc.. If we specify endPointType as BOTH then the returned column object will have both the source and target information like source system name, source environment name, source table name,source column name, target system name, target environment name , target table name and target column name etc.. And the projectIds value should be like "1,2,3.." to get the list of columns of specific projects and "null" to get the list of columns of all projects.
    Valid types of propertiesTypes are `APIConstants.PropertiesType.TECHNICAL`, `APIConstants.PropertiesType.BUSINESS`,`APIConstants.PropertiesType.NONE` If we specify the propertiesTypes as BUSINESS then the column object will have business properties like colum definition, comments etc.. If we specify the propertiesTypes as TECHNICAL then the column object will have technical properties like column length,precision etc.. If we specify the propertiesTypes as NONE then the column object will have only system,environment,table and column name only.
    Parameters:
      `endPointType` - EndPointType - valid types SOURCE, TARGET, BOTH.
      `systemEnvironmentTableMap` - Map
      `projectIds` - String
      `propertiesTypes` - EnumSet- valid types TECHNICAL, BUSINESS, NONE.
    Returns:
      Map<String, Map<String, Map<String, List>>> Object
    Throws:
      `Exception`
    Since:
      9.3

  - ### getSystemLineageAs

    public String getSystemLineageAs(String lineageType, String systemName, String projectIds, String outputFormat)
    Returns the Lineage Object String in the form of JSON for the specified system name. The returned Lineage Object contains the details about the source and target systems like systemName.
    Specification of systemName and projectIds are mandatory, and the valid types of lineageType are `APIConstants.LineageType.FORWARD`, `APIConstants.LineageType.REVERSE`, `APIConstants.LineageType.DUAL`. And the projectIds value should be like "1,2,3.." to get the lineage on specific projects and "null" to get the lineage on all projects. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `lineageType` - String - valid types FORWARD, REVERSE, DUAL.
      `systemName` - String
      `projectIds` - String - value should be like "1,2,3..."
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string
    Since:
      9.3

  - ### getEnvironmentLineageAs

    public String getEnvironmentLineageAs(String lineageType, String systemName, String environmentName, String projectIds, String outputFormat)
    Returns the Lineage Object String in the form of JSON for the specified system and environment name. The returned Lineage Object contains the details about the source and target environments like systemName, environmentName.
    Specification of systemName, environmentName and projectIds are mandatory, and the valid types of lineageType are `APIConstants.LineageType.FORWARD`, `APIConstants.LineageType.REVERSE`, `APIConstants.LineageType.DUAL`. And the projectIds value should be like "1,2,3.." to get the lineage on specific projects and "null" to get the lineage on all projects. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `lineageType` - String - valid types FORWARD, REVERSE, DUAL.
      `systemName` - String
      `environmentName` - String
      `projectIds` - String - value should be like "1,2,3..."
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string
    Since:
      9.3

  - ### getTableLineageAs

    public String getTableLineageAs(String lineageType, String systemName, String environmentName, String tableName, String projectIds, String outputFormat)
    Returns the Lineage object String in the form of JSON for the specified system, environment and table name. The returned Lineage object contains the details about the source and target tables like systemName, environmentName, tableName.
    Specification of systemName, environmentName, tableName and projectIds are mandatory, and the valid types of lineageType are `APIConstants.LineageType.FORWARD`, `APIConstants.LineageType.REVERSE`, `APIConstants.LineageType.DUAL`. And the projectIds value should be like "1,2,3.." to get the lineage on specific projects and "null" to get the lineage on all projects. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `lineageType` - String - valid types FORWARD, REVERSE, DUAL.
      `systemName` - String
      `environmentName` - String
      `tableName` - String
      `projectIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string
    Since:
      9.3

  - ### getColumnLineageAs

    public String getColumnLineageAs(String lineageType, String systemName, String environmentName, String tableName, String columnName, String projectIds, String outputFormat)
    Returns the Lineage Object String in the form of JSON for the specified system, environment, table and column name. The returned Lineage Object contains the details about the source and target columns like systemName, environmentName, tableName, columnName.
    Specification of systemName, environmentName, tableName, columnName and projectIds are mandatory, and the valid types of lineageType are `APIConstants.LineageType.FORWARD`, `APIConstants.LineageType.REVERSE`, `APIConstants.LineageType.DUAL`. And the projectIds value should be like "1,2,3.." to get the lineage on specific projects and "null" to get the lineage on all projects. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `lineageType` - String - valid types FORWARD, REVERSE, DUAL.
      `systemName` - String
      `environmentName` - String
      `tableName` - String
      `columnName` - String
      `projectIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string
    Since:
      9.3

  - ### getColumnDetailsAs

    public String getColumnDetailsAs(String endPointType, int mappingSequenceId, String outputFormat)
    Returns the List Objects String in the form of JSON for the specified mappingSequenceId.The returned SMColumn Objects contains the details about the source and target columns like systemName, environmentName, tableName, columnName, columnDataType etc..
    Specification of mappingSequenceId and endPointType are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned column object will have the source information like source system name, source environment name etc.. If we specify endPointType as TARGET then the returned column object will have the target information like target system name, target environment name etc.. If we specify endPointType as BOTH then the returned column object will have both the source and target information like source system name, source environment name, target system name, target environment name etc.. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `endPointType` - String - valid types SOURCE, TARGET, BOTH.
      `mappingSequenceId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string
    Since:
      9.3

  - ### getColumnDetailsAs

    public String getColumnDetailsAs(String endPointType, String mappingSequenceIds, String outputFormat)
    Returns the List Objects String in the form of JSON for the specified mappingSequenceIds.The returned SMColumn Objects contains the details about the source and target columns like systemName, environmentName, tableName, columnName, columnDataType etc..
    Specification of mappingSequenceId and endPointType are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned column object will have the source information like source system name, source environment name etc.. If we specify endPointType as TARGET then the returned column object will have the target information like target system name, target environment name etc.. If we specify endPointType as BOTH then the returned column object will have both the source and target information like source system name, source environment name, target system name, target environment name etc.. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `endPointType` - String - valid types SOURCE, TARGET, BOTH.
      `mappingSequenceIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string

      Sample 'mappingSequenceIds' :
      [1,2]

    Since:
      9.3

  - ### getEnvironmentsAs

    public String getEnvironmentsAs(String endPointType, String systemName, String projectIds, String outputFormat)
    Returns the List Objects String in the form of JSON for the specified systemName. The returned SMEnvironment Objects contains the details like systemName,environmentName.
    Specification of endPointType, systemName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned environment object will have the source information like source system name, source environment name etc.. If we specify endPointType as TARGET then the returned environment object will have the target information like target system name, target environment name etc.. If we specify endPointType as BOTH then the returned environment object will have both the source and target information like source system name, source environment name, target system name, target environment name etc.. And the projectIds value should be like "1,2,3.." to get the list of environments of specific projects and "null" to get the list of environments of all projects. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `endPointType` - String - valid types SOURCE, TARGET, BOTH.
      `systemName` - String
      `projectIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string
    Since:
      9.3

  - ### getEnvironmentsBySystemsAs

    public String getEnvironmentsBySystemsAs(String endPointType, String systemNames, String projectIds, String outputFormat)
    Returns the List Objects String in the form of JSON for the specified systemName. The returned SMEnvironment Objects contains the details like systemName,environmentName.
    Specification of endPointType, systemName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned environment object will have the source information like source system name, source environment name etc.. If we specify endPointType as TARGET then the returned environment object will have the target information like target system name, target environment name etc.. If we specify endPointType as BOTH then the returned environment object will have both the source and target information like source system name, source environment name, target system name, target environment name etc.. And the projectIds value should be like "1,2,3.." to get the list of environments of specific projects and "null" to get the list of environments of all projects. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `endPointType` - String - valid types SOURCE, TARGET, BOTH.
      `systemNames` - String
      `projectIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string

      Sample 'systemNames' :
      ["S1","S2","S3"]

    Since:
      9.3

  - ### getTablesAs

    public String getTablesAs(String endPointType, String systemName, String environmentName, String projectIds, String outputFormat)
    Returns the List Objects String in the form of JSON for the specified systemName and environmentName. The returned SMTable Objects contains the details like systemName, environmentName and tableName.
    Specification of endPointType, systemName, environmentName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned table object will have the source information like source system name, environment name and table name etc.. If we specify endPointType as TARGET then the returned table object will have the target information like target system name, environment name and table name etc.. If we specify endPointType as BOTH then the returned table object will have both the source and target information like source system name, source environment name, source table name, target system name, target environment name , target table name etc.. And the projectIds value should be like "1,2,3.." to get the list of tables of specific projects and "null" to get the list of tables of all projects. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `endPointType` - String - valid types SOURCE, TARGET, BOTH.
      `systemName` - String
      `environmentName` - String
      `projectIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string
    Since:
      9.3

  - ### getTablesAs

    public String getTablesAs(String endPointType, String systemEnvironmentJsonArray, String projectIds, String outputFormat)
    Returns the List Objects String in the form of JSON for the specified systemName and environmentName. The returned SMTable objects contains the details like systemName, environmentName and tableName.
    Specification of endPointType, systemName, environmentName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned table object will have the source information like source system name, environment name and table name etc.. If we specify endPointType as TARGET then the returned table object will have the target information like target system name, environment name and table name etc.. If we specify endPointType as BOTH then the returned table object will have both the source and target information like source system name, source environment name, source table name, target system name, target environment name , target table name etc.. And the projectIds value should be like "1,2,3.." to get the list of tables of specific projects and "null" to get the list of tables of all projects. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `endPointType` - String - valid types SOURCE, TARGET, BOTH.
      `systemEnvironmentJsonArray` - String
      `projectIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string

      Sample 'systemEnvironmentJsonArray' :
      ["E1","E2","E3"]

    Since:
      9.3

  - ### getColumnsAs

    public String getColumnsAs(String endPointType, String systemName, String environmentName, String tableName, String propertiesTypes, String projectIds, String outputFormat)
    Returns the List Objects String in the form of JSON for the specified systemName, environmentName and tableName. The returned SMColumn Objects contains the details like systemName, environmentName, tableName and columnName.
    Specification of endPointType, systemName, environmentName, tableName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned column object will have the source information like source system name, environment name, table name and column name etc.. If we specify endPointType as TARGET then the returned column object will have the target information like target system name, environment name, table name and column name etc.. If we specify endPointType as BOTH then the returned column object will have both the source and target information like source system name, source environment name, source table name,source column name, target system name, target environment name , target table name and target column name etc.. And the projectIds value should be like "1,2,3.." to get the list of columns of specific projects and "null" to get the list of columns of all projects.
    Valid types of propertiesTypes are `APIConstants.PropertiesType.TECHNICAL`, `APIConstants.PropertiesType.BUSINESS`, `APIConstants.PropertiesType.NONE` If we specify the propertiesTypes as BUSINESS then the column object will have business properties like colum definition, comments etc.. If we specify the propertiesTypes as TECHNICAL then the column object will have technical properties like column length,precision etc.. If we specify the propertiesTypes as NONE then the column object will have only system,environment,table and column name only. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `endPointType` - String - valid types SOURCE, TARGET, BOTH.
      `systemName` - String
      `environmentName` - String
      `tableName` - String
      `projectIds` - String
      `propertiesTypes` - String - valid types TECHNICAL, BUSINESS, NONE.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string
    Since:
      9.3

  - ### getColumnsAs

    public String getColumnsAs(String endPointType, String systemEnvironmentTableJsonArray, String propertiesTypes, String projectIds, String outputFormat)
    Returns the List Objects String in the form of JSON for the specified systemName, environmentName and tableName. The returned SMColumn objects contains the details like systemName, environmentName, tableName and columnName.
    Specification of endPointType, systemName, environmentName, tableName and projectIds are mandatory, and the valid types of endPointTypes are `APIConstants.EndPointType.SOURCE`, `APIConstants.EndPointType.TARGET`, `APIConstants.EndPointType.BOTH`. If we specify endPointType as SOURCE then the returned column object will have the source information like source system name, environment name, table name and column name etc.. If we specify endPointType as TARGET then the returned column object will have the target information like target system name, environment name, table name and column name etc.. If we specify endPointType as BOTH then the returned column object will have both the source and target information like source system name, source environment name, source table name,source column name, target system name, target environment name , target table name and target column name etc.. And the projectIds value should be like "1,2,3.." to get the list of columns of specific projects and "null" to get the list of columns of all projects.
    Valid types of propertiesTypes are `APIConstants.PropertiesType.TECHNICAL`, `APIConstants.PropertiesType.BUSINESS`, `APIConstants.PropertiesType.NONE` If we specify the propertiesTypes as BUSINESS then the column object will have business properties like colum definition, comments etc.. If we specify the propertiesTypes as TECHNICAL then the column object will have technical properties like column length,precision etc.. If we specify the propertiesTypes as NONE then the column object will have only system,environment,table and column name only. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `endPointType` - String - valid types SOURCE, TARGET, BOTH.
      `systemEnvironmentTableJsonArray` - String
      `projectIds` - String
      `propertiesTypes` - String - valid types TECHNICAL, BUSINESS, NONE.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - RequestStatus object in the form of json string

      Sample 'systemEnvironmentJsonArray' :
      {"S2":{"Env_Excel":["dbo.Categories","dbo.Customers"],"Web_Env":["dbo.ADS_ASSOCIATIONS","dbo.ADS_FORM"]}}

    Since:
      9.3

  - ### syncLineageData

    public void syncLineageData() throws Exception
    Throws:
      `Exception`
    Since:
      9.3 It will synchronize the lineage data.

  - ### resetLineageData

    public void resetLineageData() throws Exception
    Throws:
      `Exception`
    Since:
      9.3 It will reset the lineage data.

  - ### pauseLineageSync

    public void pauseLineageSync(long seconds) throws Exception
    It will pause the synchronization process of lineage for the given time.
    Parameters:
      `seconds` - long - value in seconds
    Throws:
      `Exception`
    Since:
      12.0